<?php

require_once "config.inc";
require_once "sessions.inc";
require_once "constants.inc";
require_once "db.inc";
require_once "error.inc";
require_once "privpref.inc";

function password_generator ($pass_len = 7)
{
			$allchars = 'abcdefghijklnmopqrstuvwxyz0123456789';
			$string = '';

			mt_srand ((double) microtime() * 1000000);

			for ($i = 0; $i < $pass_len; $i++)
			{

				$string .= $allchars{mt_rand (0,(strlen($allchars)-1))};
			}

			$passwdstring = strtolower ($string);
			return $passwdstring;
}

function pin_generator ($pass_len = 4)
{
			$allchars = '123456789';
			$string = '';

			mt_srand ((double) microtime() * 1000000);

			for ($i = 0; $i < $pass_len; $i++)
			{

				$string .= $allchars{mt_rand (0,(strlen($allchars)-1))};
			}

			$passwdstring = strtolower ($string);
			return $passwdstring;
}

function add_user($password)
{
	if(!check_priv("USER_MANAGEMENT"))
	{
		error("no useradd");
		exit;
	}
	else
	{
        $sql = "SELECT user_name FROM users WHERE user_name='" . $_REQUEST['user_name'] . "'";
		$sqlResult = mysql_query($sql);
		$row = mysql_fetch_array($sqlResult);
		if($row['user_name'])
		{
			return 0;
		}

        $ENABLE="";
		$BORROW="";
		$BORROWED_BOOKS="";
		$ADD="";
		$DELETE="";
		$USER_MANAGEMENT="";

		if(isset($_REQUEST['ENABLE']) && $_REQUEST['ENABLE'] == "on")
			$ENABLE = "ENABLE";
		if(isset($_REQUEST['BORROW']) && $_REQUEST['BORROW'] == "on")
			$BORROW = "BORROW";
		if(isset($_REQUEST['BORROWED_BOOKS']) && $_REQUEST['BORROWED_BOOKS'] == "on")
			$BORROWED_BOOKS = "BORROWED_BOOKS";
		if(isset($_REQUEST['ADD']) && $_REQUEST['ADD'] == "on")
			$ADD = "ADD";
		if(isset($_REQUEST['DELETE']) && $_REQUEST['DELETE'] == "on")
			$DELETE = "DELETE";
		if(isset($_REQUEST['USERMANAGEMENT']) && $_REQUEST['USERMANAGEMENT'] == "on")
			$USER_MANAGEMENT = "USER_MANAGEMENT";

		$priv = set_priv($ENABLE, $BORROW, $BORROWED_BOOKS, $ADD, $DELETE, $USER_MANAGEMENT);

		$md5_password = md5($password);

		$sql = "INSERT INTO users SET user_realname='" . $_REQUEST['user_realname'] . "', user_name='" . $_REQUEST['user_name'] . "', user_email='" . $_REQUEST['user_email'] . "', user_lang=" . $_REQUEST['user_language'] . ", user_dateformat=" . $_REQUEST['user_dateformat'] . ", user_priv=" . $priv . ", user_password='" . $md5_password . "'";
		$sqlResult = mysql_query($sql);
		if($sqlResult)
		{
                        writeLog("User added: " . mysql_insert_id() . " (" . $_REQUEST['user_name'] . " - " . $_REQUEST['user_realname'] . ")", $_REQUEST['id'], USER_ID);
                        return 1;
		}
		else
		{
			return 0;
		}
	}
}

function update_user()
{
	global $langText;

        if(!check_priv("USER_MANAGEMENT"))
	{
		error("no useradd");
		exit;
	}
	else
	{
                $sql = "SELECT * FROM users WHERE user_id=" . $_REQUEST['edit_id'];
		$sqlResult = mysql_query($sql);
		$row = mysql_fetch_array($sqlResult);

		$ENABLE="";
		$BORROW="";
		$BORROWED_BOOKS="";
		$ADD="";
		$DELETE="";
		$USER_MANAGEMENT="";

		if(isset($_REQUEST['ENABLE']) && $_REQUEST['ENABLE'] == "on")
			$ENABLE = "ENABLE";
		if(isset($_REQUEST['BORROW']) && $_REQUEST['BORROW'] == "on")
			$BORROW = "BORROW";
		if(isset($_REQUEST['BORROWED_BOOKS']) && $_REQUEST['BORROWED_BOOKS'] == "on")
			$BORROWED_BOOKS = "BORROWED_BOOKS";
		if(isset($_REQUEST['ADD']) && $_REQUEST['ADD'] == "on")
			$ADD = "ADD";
		if(isset($_REQUEST['DELETE']) && $_REQUEST['DELETE'] == "on")
			$DELETE = "DELETE";
		if(isset($_REQUEST['USERMANAGEMENT']) && $_REQUEST['USERMANAGEMENT'] == "on")
			$USER_MANAGEMENT = "USER_MANAGEMENT";

		$priv = set_priv($ENABLE, $BORROW, $BORROWED_BOOKS, $ADD, $DELETE, $USER_MANAGEMENT);
                $md5_password = $row['user_password'];

		if(isset($_REQUEST['user_new_password']))
		{
                        if($_REQUEST['user_new_password'])
                        {
                        	if($_REQUEST['user_new_password'] == $_REQUEST['user_retype_password'])
				{
                                	$md5_password = md5($_REQUEST['user_new_password']);
				}
				else
				{
					print $langText['ERROR_PWD_NOMATCH'];
					exit;
				}
                        }
		}

		$sql = "UPDATE users SET user_realname='" . $_REQUEST['user_realname'] . "', user_email='" . $_REQUEST['user_email'] . "', user_lang=" . $_REQUEST['user_lang'] . ", user_dateformat=" . $_REQUEST['user_dateformat'] . ", user_priv=" . $priv . ", user_password='" . $md5_password . "' WHERE user_id=" . $_REQUEST['edit_id'];
		$sqlResult = mysql_query($sql);
		if(mysql_affected_rows())
		{
                        writeLog("User modified: " . $_REQUEST['edit_id'] . " (" . $_REQUEST['user_realname'] . ")", $_REQUEST['id'], USER_ID);
                        return 1;
		}
		else
		{
			return 0;
		}
	}
}

function attachable_users($group_id, $user_id = USER_ID)
{
	$user_rows = array();

	$user = mysql_fetch_array(mysql_query("SELECT user_location FROM users WHERE user_id=".$user_id));

	if(check_priv("ADMIN"))
	{
		$res = mysql_query(	"SELECT user_id, user_given_names, user_surname, user_cast
							FROM users
							WHERE user_id NOT IN
								(SELECT user_id
								FROM linkage WHERE group_id=".$group_id.")
							ORDER BY users.user_surname");
	}
	elseif(check_priv("POWER"))
	{
		$res = mysql_query(	"SELECT user_id, user_given_names, user_surname, user_cast
							FROM users
							WHERE user_id IN
                            	(SELECT user_id
								FROM linkage
								WHERE group_id IN
									(SELECT group_id FROM linkage
									WHERE user_id=".$user_id."))
							AND user_id NOT IN
								(SELECT user_id
								FROM linkage WHERE group_id=".$group_id.")
							ORDER BY user_surname");

	}

	while($row = mysql_fetch_array($res))
	{
		$attach_id = $row['user_id'];
		
		if(check_priv("ADMIN"))
			array_push($user_rows, $row);
		elseif(check_priv("POWER") && check_priv("NORMAL", $attach_id))
			array_push($user_rows, $row);
	}

	//print_r($user_rows);
	return $user_rows;
}

function attaching_allowed($attach_id, $group_id, $user_id = USER_ID)
{
	if(is_group_manager($group_id, $user_id))
	{
		$res = mysql_query("SELECT * FROM linkage WHERE user_id=".$attach_id." AND group_id=".$group_id);
		if(mysql_num_rows($res))
			return 0;
		else
		{
			if(check_priv("ADMIN"))
				return 1;
			elseif(check_priv("POWER") && check_priv("NORMAL", $attach_id))
				return 1;
			else
				return 0;
		}
	}
	else
		return 0;
}

function is_group_manager($group_id, $user_id = USER_ID)
{
	$res = mysql_query("SELECT * FROM linkage WHERE group_id=".$group_id." AND user_id=".$user_id);

	while($row = mysql_fetch_array($res))
	{
		if($row['group_manager'] == 1)
			return 1;
		else
			return 0;
	}

	return 0;
}

function can_be_group_manager($user_id = USER_ID)
{
	if(check_priv("GROUP_MANAGEMENT", $user_id) && (check_priv("POWER", $user_id) || check_priv("ADMIN", $user_id)))
		return 1;
	else
		return 0;
}

function promote_to_admin($user_id)
{
	$res = mysql_query("SELECT group_id FROM groups WHERE group_id NOT IN (SELECT group_id FROM linkage WHERE user_id=".$user_id.")");

	while($row = mysql_fetch_array($res))
	{
		mysql_query("INSERT INTO linkage SET user_id=".$user_id.", group_id=".$row['group_id'].", group_manager=1, visible=0, view_borrowed=1");
	}
}

function degrade_from_admin($user_id)
{
	mysql_query("DELETE FROM linkage WHERE user_id=".$user_id);
}

function view_borrowed_allowed($group_id)
{
	$res = mysql_query("SELECT group_view_borrowed FROM groups WHERE group_id=".$group_id);
	
	while($row = mysql_fetch_array($res))
	{
		if($row['group_view_borrowed'] == 1)
			return 1;
		else
			return 0;
	}
}

function can_view_borrowed($who, $me = USER_ID)
{
	$success = 0;

	if(check_priv("ADMIN"))
		return 1;

	if(check_priv("BORROWED_BOOKS"))
	{
 		$res = mysql_query(	"SELECT user_id FROM linkage WHERE group_id IN
								(SELECT group_id FROM linkage WHERE user_id=".$me." && view_borrowed=1)
							&& visible=1");
        while($row = mysql_fetch_array($res))
        {
			if($row['user_id'] == $who)
				$success = 1;
		}

		if($success)
			return 1;
		else
			return 0;
	}
	else
       	return 0;
}

function zebra_list_syntax($comma_separated_list)
{
	$book_ids = array();
	$book_ids_only = array();
	$ii = 1;

	$books = split(",", $comma_separated_list);

	foreach ($books as $id)
	{
		/*print "ID:".$id."<br>";
		print_r($books);
		print "<br>";*/

		$row = mysql_fetch_array(mysql_query("SELECT book_control_number FROM books WHERE book_id=".$id));
		if($ii == 1) {
			array_push($book_ids, format_control_number($row['book_control_number']));
			array_push($book_ids_only, format_control_number($row['book_control_number']));
		}
		elseif($ii == 2) {
			array_push($book_ids, '" @or "',format_control_number($row['book_control_number']), '" @or "');
			array_push($book_ids_only, format_control_number($row['book_control_number']));
		}
		else {
			array_push($book_ids,format_control_number($row['book_control_number']), '" @or "');
			array_push($book_ids_only, format_control_number($row['book_control_number']));
		}

		if($ii == count($books) && count($books) > 1) {
			$l = (count($book_ids)-1);
			$book_ids[$l-2] = '" "';
			array_pop($book_ids);
		}
		$ii++;
    }

	$book_list = join("", $book_ids);

	return array($book_list, $book_ids_only, $books);
}

function superiors_list($user_id = USER_ID)
{
	$superiors = array();

 	$res = mysql_query(	"SELECT user_given_names, user_surname, user_id
						FROM users
						WHERE user_id IN
							(SELECT user_id
							FROM linkage
							WHERE group_manager=1 &&
							group_id IN
								(SELECT group_id
								FROM linkage
								WHERE user_id=".$user_id.")) &&
						user_id!=".$user_id."
						ORDER BY user_surname ASC");

	while($row = mysql_fetch_array($res))
	{
    	$superiors[$row['user_id']] = $row['user_surname'] . ", " . $row['user_given_names'];
	}
	return $superiors;
}

function system_admins_list()
{
 	$admin_list = array();

	$res = mysql_query(	"SELECT user_given_names, user_surname, user_id
						FROM users
						WHERE user_cast='ADMIN'
						ORDER BY user_surname ASC");

	while($row = mysql_fetch_array($res))
	{
    	$admin_list[$row['user_id']] = $row['user_surname'] . ", " . $row['user_given_names'];
	}
	return $admin_list;
}

function format_reply_message($orig, $from)
{
	global $langText;
	$new = array("\n> ", $from, " ", $langText['WROTE'], ": ", "\n", "> ", "\n", "> ");
	$row_length = 1;
	$word_count = 0;

	$words = split(" ", $orig);

	foreach($words as $word)
	{
		if(($row_length + $word_count) >= 40)
		{
			array_push($new, " \n> " . $word . " ");
			$row_length = 1;
			$word_count = 0;
		}
		elseif(stristr($word, "\n"))
		{
       		$word = str_replace("\n", "\n> ", $word);
			array_push($new, $word." ");
			$row_length = 1;
			$word_count = 0;
		}
		else
		{
			array_push($new, $word." ");
			$word_count++;
			$row_length += strlen($word);
		}
	}

    //print_r($words);
	return join("", $new);
}

function format_message($message)
{
 	global $langText;

    if(stristr($message, "#####"))
	{
		$parts = split("#####", $message);
		$link = end($parts);

		$orig = $link;

		$message = str_replace("#####", "", $message);
		$link = str_replace("[SUGGESTION]", "", $link);
		$link = str_replace("[/SUGGESTION]", "", $link);
		$link = str_replace("[ID]", $_REQUEST['id'], $link);
		$link = str_replace("[AUTH]", $_REQUEST['auth'], $link);
		$link = str_replace("[SUGGESTION]", "", $link);

		$new = "-----\n<a href='".$link."'>".$langText['BOOK_INFO']."</a>";

		$message_raw = str_replace($orig, "", $message);
		$message = str_replace($orig, $new, $message);

		return array(nl2br($message), $message_raw, "#####".$orig);
	}
	else
		return array(nl2br($message), nl2br($message), "");
}

function format_reply_subject($subject)
{
 	if(!stristr($subject, "RE:"))
		return "RE: ".$subject;
	else
		return $subject;
}

function format_user_real_name($mysql_row)
{
	return $mysql_row['user_given_names']." ".$mysql_row['user_surname'];
}

function format_card_number($id)
{
	global $config;

	$user = mysql_fetch_array(mysql_query("SELECT user_name, user_id FROM users WHERE user_card_number='".$id."'"));

	if(($user['user_name'] == $id && $user['user_id'] == $id) || (!is_numeric($user['user_name']) && $user['user_id'] == $id))
	{
		$length = strlen($id);
		//print "LEN:".$length."ZER:".($config['card_number_length'] - $length)."<br>";
		$zeros = "";
		for($i=0;$i < ($config['card_number_length'] - $length);$i++)
		{
			$zeros .= "0";
		}
		return $zeros.$id.$config['card_number_suffix'];
	}
	else
		return $id;
}

function valid_card_number($number, $user_id = "")
{
	global $config;

	if(is_last_char($number, $config['card_number_suffix']))
		$number = chop_last($number);
		
	//print "TEST: ".$number;

    if($user_id == "") {
		if(is_numeric($number)) {
			$res = mysql_query("SELECT user_id FROM users WHERE user_card_number=".$number);
		} else {
			$res = mysql_query("SELECT user_id FROM users WHERE user_card_number='".$number."'");
		}
	}
    else {
		if(is_numeric($number)) {
			$res = mysql_query("SELECT user_id FROM users WHERE user_id=$user_id AND user_card_number=".$number);
		} else {
			$res = mysql_query("SELECT user_id FROM users WHERE user_id=$user_id AND user_card_number='".$number."'");
		}
		
		if(mysql_num_rows($res))
			return FALSE;
		else
			return TRUE;
	}
	

	if(mysql_num_rows($res))
		return TRUE;
	else
		return FALSE;
}

function is_last_char($string, $key)
{
	//print "STRING TO CHECK: ".$string."<br>";
	if (strlen($string) > 0 && $string[strlen($string) - 1] == $key) {
		//print "TRUE!<br>";
		return true;}
	else {
		//print "FALSE!<br>";
		return false;}
}

function is_first_char($string, $key)
{
	if($string[0] == $key) {
		//print "TRUE!<br>";
		return TRUE;
	}
	else {
		//print "FALSE!<br>";
		return FALSE;
	}
}

function chop_last($string)
{
	return substr($string, 0, -1);
}

function pop_first($string)
{
	return substr($string, 1);
}

function move_from_allowed($target_user_id, $by_who = USER_ID)
{
	if(check_priv("ADMIN")) {
		$res = mysql_query(	"SELECT linkage.group_id FROM users, linkage
							WHERE users.user_id=linkage.user_id &&
								users.user_id=".$target_user_id);
	}
	elseif(check_priv("POWER")) {
		$res = mysql_query(	"SELECT linkage.group_id FROM users, linkage
							WHERE users.user_id=linkage.user_id &&
								users.user_id=".$target_user_id." &&
								linkage.group_id IN
									(SELECT group_id
									FROM linkage
									WHERE group_manager=1 && user_id=".$by_who.")");
	}

	if(isset($res)) {
		$group_ids = array();
		while($row = mysql_fetch_array($res))
		{
			array_push($group_ids, $row['group_id']);
		}
	}
	else {
		$group_ids = array();
	}

	return $group_ids;
}

function move_to_allowed($target_user_id, $by_who = USER_ID)
{
					if(check_priv("ADMIN")) {
						$res = mysql_query(	"SELECT group_id FROM groups");
					}
					elseif(check_priv("POWER")) {
						$res = mysql_query(	"SELECT linkage.group_id FROM users, linkage
											WHERE users.user_id=linkage.user_id &&
												users.user_id=".$target_user_id." &&
												linkage.group_id IN
													(SELECT group_id
													FROM linkage
													WHERE group_manager=1 && user_id=".$by_who.")");
					}

	if(isset($res)) {
		$group_ids = array();
		while($row = mysql_fetch_array($res))
		{
			array_push($group_ids, $row['group_id']);
		}
	}
	else {
		$group_ids = array();
	}

	return $group_ids;
}

function book_suggest_message($by_who, $control_number, $url)
{
	global $MARC, $langText, $MARC_display_in_list, $MARC_config;
	$message = "";
	$hidden = "";

	list($YAZ_items, $hits) = search("001", $control_number, 1, 10, $url);
	parseMARC($YAZ_items[0]);
	$row = createMARCRow(return_with_format_syntax($MARC_display_in_list));

	$message .= $langText['SUGGEST_HEADER'].": ".$by_who."\n----\n";

	foreach($row as $key => $value)
	{
		$message .= $langText[strtoupper($key)].": ".$value."\n";
	}

	$message .= "----\n";
	$message .= $langText['USER_COMMENTS'].": \n\n\n\n";

	$hidden .= "#####";
	$hidden .= "[SUGGESTION]book_info.php?id=[ID]&auth=[AUTH]&url=".$url."&book_control_number=".$control_number."[/SUGGESTION]";


	return array($message, $hidden);

}

function inform_reservant($book_id, $to)
{
	global $langText, $MARC_display_in_list;
	$message = "";
	
	$old_langText = $langText;
	$uinfo = mysql_fetch_array(mysql_query("SELECT user_lang FROM users WHERE user_id=".$to));
	parseLang($uinfo['user_lang']);
	
	$book = mysql_fetch_array(mysql_query("SELECT book_control_number FROM books WHERE book_id=".$book_id));

	$_REQUEST['element'] = 'F';
	//print "CN: ".$book['book_control_number'];

	list($YAZ_items, $hits) = search("001", format_control_number($book['book_control_number']), 1);
	parseMARC($YAZ_items[0]);
	$row = createMARCRow(return_with_format_syntax($MARC_display_in_list));

	$message .= $langText['RESERVED_TEXT_1']." ";
	$message .= "\"".$row['book_author']." - ".$row['book_title']."\" ";
	$message .= $langText['RESERVED_TEXT_2']." ";
	$message .=	$langText['RESERVED_TEXT_3']."\n\n";
	$message .= $langText['RESERVED_FOOTER'];


	$res = mysql_query(	"INSERT INTO messages
					SET message_to_id=".$to.",
					message_from_id='0',
					message_sent=NOW(),
					message_nature='1',
					message_subject='".$langText['RESERVED_SUBJECT']."',
					message_text='".$message."',
					message_read=0");
					
	$langText = $old_langText;
}

function valid_email_address($address)
{
 	if(stristr($address, "@") && stristr($address, "."))
	{
		$parts = split("[@.]", $address);
		//print_r($parts);

		if(count($parts) >= 3)
			return TRUE;
		else
			return FALSE;
	}
	else
		return FALSE;
}

function email_reminder($user_id)
{
	global $langText, $MARC_display_in_list, $MARC;

	$row = mysql_fetch_array(mysql_query("SELECT * FROM users WHERE user_id=".$user_id));

	$res = mysql_query("SELECT *, UNIX_TIMESTAMP(borrowed.borrowed_date) as borrowed_epoch FROM borrowed, books WHERE borrowed.borrowed_book_id=books.book_id && borrowed.borrowed_user_id=".$user_id);

	if(mysql_num_rows($res))
	{
		parseLang($row['user_lang']);
		$to = "\"".format_user_real_name($row)."\" <".$row['user_email'].">";
		$message = $langText['REMINDER_TEXT']."\n\n\n";

		while($book = mysql_fetch_array($res))
		{
			list($expiry_format, $expiry_epoch) = expiry_date($book['borrowed_epoch']);

			if($expiry_epoch < time())
			{

				$_REQUEST['element'] = "F";
				list($YAZ_items, $hits) = search("001", format_control_number($book['book_control_number']), "1");
				parseMARC($YAZ_items[0]);
				$MARCrow = createMARCRow(return_with_format_syntax($MARC_display_in_list));

				$message .= $langText['BOOK_AUTHOR'].": ".$MARCrow['book_author']."\n";
				$message .= $langText['BOOK_TITLE'].": ".$MARCrow['book_title']."\n";
				$message .= $langText['BOOK_ID'].": ".format_book_id($book['book_id'])."\n";
				$message .= $langText['EXPIRED'].": ".$expiry_format."\n";
				$message .= $langText['BORROWED_DATE'].": ".date($row['user_date_format'], $book['borrowed_epoch'])."\n\n";
			}
		}

		$headers = "From: Emilda <emilda-no-reply@" . getenv("SERVER_NAME") . ">\r\n";
		$result = mail($to, $langText['REMINDER_SUBJECT'], html_entity_decode($message), $headers);

		parseLang();

		if($result)
			return TRUE;
		else
			return FALSE;
	}
	else
		return FALSE;

}

function get_base_url()
{
	$url = "";
	$i = 0;

	$url .= "http://";
	$url .= getenv('HTTP_HOST');
	$split = split("/", getenv('SCRIPT_NAME'));
	while($i + 1 < count($split))
	{
		$url .= $split[$i]."/";
		$i++;
	}
	return $url;
}

function format_motd($message)
{
	$final = "";
	$message = nl2br($message);

	$words = split(" ", $message);
	foreach($words as $word)
	{
		if(strlen($word) > 30) {
			$i=0;
			$new = "";
			while($i < strlen($word))
			{
				if($i % 29 == 0 && $i != 0)
					$new .= "-<br>";

				$new .= $word[$i];
				$i++;
			}
			$word = $new;
		}

		$final .= " ".$word;
	}
	return $final;
}

function get_templates()
{
	$templates = array();

	$handle = opendir("./templates/");
	while (FALSE !== ($file = readdir($handle)))
	{
		if (substr($file, 0, 1) != '.' && $file != "CVS")
		{
        	array_push($templates, $file);
		}
	}
	closedir($handle);

	return $templates;
}

function allowable_username($string, $user_id = "")
{
	global $config;

	if (preg_match("/^[0-9]*".$config['card_number_suffix']."$/", $string)) {
		if(is_last_char($_REQUEST['user_card_number'], $config['card_number_suffix'])) {
			$_REQUEST['user_card_number'] = chop_last($_REQUEST['user_card_number']);
			
		    if(is_numeric($number)) {
				$res = mysql_query("SELECT user_id FROM users WHERE user_id=$user_id AND user_card_number=".$number);
			} else {
				$res = mysql_query("SELECT user_id FROM users WHERE user_id=$user_id AND user_card_number='".$number."'");
			}

			if(mysql_num_rows($res)) {
				return TRUE;
			} else {
				return FALSE;
			}
		} else {
			return FALSE;
		}
	} else {
		return TRUE;
	}
}

?>
